#!/usr/bin/ruby
# $Id: scrape-MDAPI-1-tiderefs.rb 6700 2018-01-04 15:27:34Z flaterco $
# 2017-12-17 15:55
# Given harcon.json from scrape-MDAPI-0-stationlists.sh, get the harmonic
# constants and datums for all tide reference stations.

require 'json'

subdir = "tiderefs"
Dir.mkdir(subdir) unless File.exist?(subdir)

Dir.chdir(subdir) do
  unless File.exist?("urls.txt")
    harcon = JSON.parse(File.read("../harcon.json"))
    File.open("urls.txt", "w") do |outf|
      harcon["stations"].each {|x|
	outf.puts x["datums"]["self"]
	outf.puts x["harmonicConstituents"]["self"]
      }
    end
  end

  system "wget --force-directories --no-host-directories --cut-dirs=4 --wait=10 --random-wait --no-clobber --input-file=urls.txt --append-output=scrape_log.txt"
end
