#!/usr/bin/ruby
# $Id: scrape-MDAPI-2-geogroups.rb 6706 2018-01-06 21:17:43Z flaterco $
#
# FIXME:  Recheck all this on next use.  As of 2017,
# - The geogroups query is undocumented (but is used by the tidesub pages);
# - The children query does not work for currents;
# - The lvl= field apparently has no effect.

require 'json'

# Get the list of geogroups with parent pointers.
# The example uses &lvl=4, but &lvl= anything makes no difference.
unless File.exist?("geogroups-tides.json")
  system "wget -O geogroups-tides.json https://tidesandcurrents.noaa.gov/mdapi/latest/webapi/geogroups.json?type=ETIDES"
end

# Make list of URLs to get the stations in each geogroup.
unless File.exist?("geogroups-tides-urls.txt")
  geogroups = JSON.parse(File.read("geogroups-tides.json"))
  File.open("geogroups-tides-urls.txt", "w") do |outf|
    geogroups["geoGroupList"].each {|g|
      outf.print "https://tidesandcurrents.noaa.gov/mdapi/latest/webapi/geogroups/", g["geoGroupId"], "/children.json\n"
    }
  end
end

# Not sure what the seq field is for.

# The records all contain pointers to the parent geogroup, so it's not
# necessary to save separate files for each get.
unless File.exist?("stations-by-group-tides.json")
  system "wget -O stations-by-group-tides.json --wait=4 --random-wait --no-clobber --input-file=geogroups-tides-urls.txt --append-output=scrape_log_geogroups_tides.txt"
end

# Repeat for currents.

unless File.exist?("geogroups-currents.json")
  system "wget -O geogroups-currents.json https://tidesandcurrents.noaa.gov/mdapi/latest/webapi/geogroups.json?type=CURRENTS"
end

# The rest is pointless as of 2017.
=begin
unless File.exist?("geogroups-currents-urls.txt")
  geogroups = JSON.parse(File.read("geogroups-currents.json"))
  File.open("geogroups-currents-urls.txt", "w") do |outf|
    geogroups["geoGroupList"].each {|g|
      outf.print "https://tidesandcurrents.noaa.gov/mdapi/latest/webapi/geogroups/", g["geoGroupId"], "/children.json\n"
    }
  end
end

# This retrieves nothing but the group records.
unless File.exist?("stations-by-group-currents.json")
  system "wget -O stations-by-group-currents.json --wait=4 --random-wait --no-clobber --input-file=geogroups-currents-urls.txt --append-output=scrape_log_geogroups_currents.txt"
end
=end
